<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>fwConfigurationDB: fwConfigurationDB_Hierarchies.ctl File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">fwConfigurationDB
   &#160;<span id="projectnumber">8.4.3</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('fwConfigurationDB__Hierarchies_8ctl.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">fwConfigurationDB_Hierarchies.ctl File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader">Indexing constants for deviceListObject variables</h2></td></tr>
<tr><td class="ititle" colspan="2"><p><a class="anchor" id="amgrp5898d7a8206ba43cc817184c422aaed3"></a>The following constants are used to refer to the data in a single row of a deviceListObject variable (a recipeRow). </p>
</td></tr>
<tr class="memitem:a540a3195b7b2b0aac5bea7c89f783aa2"><td class="memItemLeft" align="right" valign="top"><a id="a540a3195b7b2b0aac5bea7c89f783aa2"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_DPNAME</b> = 1</td></tr>
<tr class="separator:a540a3195b7b2b0aac5bea7c89f783aa2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f2060e60dd95327d625a3c26d3942ee"><td class="memItemLeft" align="right" valign="top"><a id="a6f2060e60dd95327d625a3c26d3942ee"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_DPTYPE</b> = 2</td></tr>
<tr class="separator:a6f2060e60dd95327d625a3c26d3942ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a229530be65e56efb148414b710fff717"><td class="memItemLeft" align="right" valign="top"><a id="a229530be65e56efb148414b710fff717"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_NAME</b> = 3</td></tr>
<tr class="separator:a229530be65e56efb148414b710fff717"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab428a42aec45f67f0ebb3daffa4c3cde"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#ab428a42aec45f67f0ebb3daffa4c3cde">fwConfigurationDB_DLO_MODEL</a> = 5</td></tr>
<tr class="separator:ab428a42aec45f67f0ebb3daffa4c3cde"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4013a964bd2741fa5e0edc318bfd0ef8"><td class="memItemLeft" align="right" valign="top"><a id="a4013a964bd2741fa5e0edc318bfd0ef8"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_COMMENT</b> = 6</td></tr>
<tr class="separator:a4013a964bd2741fa5e0edc318bfd0ef8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33470ed2f27809741effb6e70c0e35b9"><td class="memItemLeft" align="right" valign="top"><a id="a33470ed2f27809741effb6e70c0e35b9"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_ITEMID</b> = 7</td></tr>
<tr class="separator:a33470ed2f27809741effb6e70c0e35b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac432f1171357b94b33123f1c436a0473"><td class="memItemLeft" align="right" valign="top"><a id="ac432f1171357b94b33123f1c436a0473"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_PARENTID</b> = 8</td></tr>
<tr class="separator:ac432f1171357b94b33123f1c436a0473"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a333e6543391cad682b43c1e8a10a6f41"><td class="memItemLeft" align="right" valign="top"><a id="a333e6543391cad682b43c1e8a10a6f41"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_PARENTDPNAME</b> = 9</td></tr>
<tr class="separator:a333e6543391cad682b43c1e8a10a6f41"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4b65c74641270858f4192a9b314b2a4"><td class="memItemLeft" align="right" valign="top"><a id="ad4b65c74641270858f4192a9b314b2a4"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_DPID</b> = 10</td></tr>
<tr class="separator:ad4b65c74641270858f4192a9b314b2a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb7a77189eaa8504ae54744cfc0cf5a1"><td class="memItemLeft" align="right" valign="top"><a id="acb7a77189eaa8504ae54744cfc0cf5a1"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_REFDP</b> = 11</td></tr>
<tr class="separator:acb7a77189eaa8504ae54744cfc0cf5a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab345b3f7668874bdbbba0696febe8da"><td class="memItemLeft" align="right" valign="top"><a id="aab345b3f7668874bdbbba0696febe8da"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_REFID</b> = 12</td></tr>
<tr class="separator:aab345b3f7668874bdbbba0696febe8da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a88bb126c9aa2426e519ddd00c22430ec"><td class="memItemLeft" align="right" valign="top"><a id="a88bb126c9aa2426e519ddd00c22430ec"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_REF_STATUS</b> = 13</td></tr>
<tr class="separator:a88bb126c9aa2426e519ddd00c22430ec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb68607905aa1da8f34eef360cb24eb3"><td class="memItemLeft" align="right" valign="top"><a id="aeb68607905aa1da8f34eef360cb24eb3"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_PROPIDS</b> = 14</td></tr>
<tr class="separator:aeb68607905aa1da8f34eef360cb24eb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a012ca9484346446b0c0bfb4ec46238a3"><td class="memItemLeft" align="right" valign="top"><a id="a012ca9484346446b0c0bfb4ec46238a3"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_PROPNAMES</b> = 15</td></tr>
<tr class="separator:a012ca9484346446b0c0bfb4ec46238a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3427d5952bd36330388bec5764eabdca"><td class="memItemLeft" align="right" valign="top"><a id="a3427d5952bd36330388bec5764eabdca"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_CITEM_ID</b> = 16</td></tr>
<tr class="separator:a3427d5952bd36330388bec5764eabdca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9461722fc07d303c4ae2ed6b8368ebe"><td class="memItemLeft" align="right" valign="top"><a id="ae9461722fc07d303c4ae2ed6b8368ebe"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_DLO_MAX_IDX</b> = 16</td></tr>
<tr class="separator:ae9461722fc07d303c4ae2ed6b8368ebe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb43220159ec10c9fc134a85931362d5"><td class="memItemLeft" align="right" valign="top"><a id="aeb43220159ec10c9fc134a85931362d5"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_updateDeviceConfigurationFromDB</b> (string configurationName, string hierarchyType, dyn_string &amp;exceptionInfo, time validOn=0, dyn_string deviceList=&quot;&quot;, string systemName=&quot;&quot;, int options=fwConfigurationDB_deviceConfig_ALLDEVPROPS)</td></tr>
<tr class="separator:aeb43220159ec10c9fc134a85931362d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2160aaa26b8d3c747f689aeb4b4a4b69"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#a2160aaa26b8d3c747f689aeb4b4a4b69">fwConfigurationDB_getHierarchyFromPVSS</a> (string rootNode, string hierarchyType, dyn_string &amp;nodeList, dyn_string &amp;exceptionInfo, string system=&quot;&quot;, string includeRootNode=TRUE)</td></tr>
<tr class="separator:a2160aaa26b8d3c747f689aeb4b4a4b69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ac41af87b3933fc92243bc39812110e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#a1ac41af87b3933fc92243bc39812110e">_fwConfigurationDB_copyDeviceListObjectEntry</a> (dyn_dyn_mixed &amp;srcObject, int src_idx, dyn_dyn_mixed &amp;dstObject, int dst_idx, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a1ac41af87b3933fc92243bc39812110e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a31f0f8797563642a31fc1aa052be387c"><td class="memItemLeft" align="right" valign="top"><a id="a31f0f8797563642a31fc1aa052be387c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_ensureDeviceListObjectValid</b> (dyn_dyn_mixed &amp;obj)</td></tr>
<tr class="separator:a31f0f8797563642a31fc1aa052be387c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4b6426bf88b2da16474a53fb3d75a2b4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#a4b6426bf88b2da16474a53fb3d75a2b4">fwConfigurationDB_expandToDeviceListObject</a> (string hierarchyType, dyn_string deviceList, dyn_dyn_mixed &amp;deviceListObject, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a4b6426bf88b2da16474a53fb3d75a2b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae700adb9356bc6facaa480b79905a536"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#ae700adb9356bc6facaa480b79905a536">_fwConfigurationDB_completeDevicesInHierarchy</a> (dyn_string &amp;deviceList, string hierarchyType, string system, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ae700adb9356bc6facaa480b79905a536"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add0cbfb4d594b22b8d4e004fc73ec52c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#add0cbfb4d594b22b8d4e004fc73ec52c">_fwConfigurationDB_verifyDatapoints</a> (string hierarchyType, dyn_dyn_mixed &amp;deviceListObject, dyn_dyn_mixed &amp;missingDevicesListObject, dyn_string &amp;exceptionInfo, bool checkDeviceLocal=FALSE)</td></tr>
<tr class="separator:add0cbfb4d594b22b8d4e004fc73ec52c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac726fbc3d8788d9e4461d29ff5da6fef"><td class="memItemLeft" align="right" valign="top"><a id="ac726fbc3d8788d9e4461d29ff5da6fef"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_createDevices</b> (dyn_dyn_mixed deviceListObject, string hierarchyType, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ac726fbc3d8788d9e4461d29ff5da6fef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a20d39a87b9b0bbffb6093e07614d80ba"><td class="memItemLeft" align="right" valign="top"><a id="a20d39a87b9b0bbffb6093e07614d80ba"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_configureDevices</b> (dyn_dyn_mixed &amp;deviceListObject, string hierarchyType, dyn_string &amp;exceptionInfo, int options=fwConfigurationDB_deviceConfig_ALLDEVPROPS)</td></tr>
<tr class="separator:a20d39a87b9b0bbffb6093e07614d80ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f03bb62117381e4a4142b49a33f7082"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#a6f03bb62117381e4a4142b49a33f7082">fwConfigurationDB_getReferencesHistory</a> (string configName, string hierarchyType, time startTime, time endTime, dyn_string itemNames, dyn_dyn_mixed &amp;references, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a6f03bb62117381e4a4142b49a33f7082"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07928ddc4821e146e022bdb616b458e5"><td class="memItemLeft" align="right" valign="top"><a id="a07928ddc4821e146e022bdb616b458e5"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_getDeviceConfigurations</b> (string hierarchyType, dyn_string &amp;confNames, dyn_string &amp;confDescriptions, dyn_int &amp;confIds, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a07928ddc4821e146e022bdb616b458e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adf65dfe5622561ff8897490383be3852"><td class="memItemLeft" align="right" valign="top"><a id="adf65dfe5622561ff8897490383be3852"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_deleteDeviceConfiguration</b> (string confName, dyn_string &amp;exceptionInfo, bool deleteOldOnly=false)</td></tr>
<tr class="separator:adf65dfe5622561ff8897490383be3852"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2716a50be767cd1d781c01704532a04d"><td class="memItemLeft" align="right" valign="top"><a id="a2716a50be767cd1d781c01704532a04d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_checkSaveDpTypes</b> (dyn_string dpTypes, dyn_int &amp;dpTypeIds, dyn_mixed &amp;dpTypeElements, dyn_mixed &amp;dpTypeElementIds, time date, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a2716a50be767cd1d781c01704532a04d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a02f856d22138ee4a67ab62df9c80ef06"><td class="memItemLeft" align="right" valign="top"><a id="a02f856d22138ee4a67ab62df9c80ef06"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_configureFwDevicesWithDefaults</b> (dyn_string &amp;dps, dyn_string &amp;dptypes, dyn_string &amp;models, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a02f856d22138ee4a67ab62df9c80ef06"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f5c035e2d668560a939aa10cef8b3b9"><td class="memItemLeft" align="right" valign="top"><a id="a1f5c035e2d668560a939aa10cef8b3b9"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_configureDevicesFromDB</b> (dyn_string &amp;exceptionInfo, int options=fwConfigurationDB_deviceConfig_ALLDEVPROPS)</td></tr>
<tr class="separator:a1f5c035e2d668560a939aa10cef8b3b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7f81f8ead600de09cad07640da6fb40"><td class="memItemLeft" align="right" valign="top"><a id="ab7f81f8ead600de09cad07640da6fb40"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_getIpropIdsInConfiguration</b> (string configurationName, dyn_string &amp;dpes, dyn_int &amp;ipropIds, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ab7f81f8ead600de09cad07640da6fb40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeed6f486bee7176ca8a4f3af3836f3d9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#aeed6f486bee7176ca8a4f3af3836f3d9">fwConfigurationDB_updateDeviceModelsInDB</a> (dyn_string dpList, dyn_string &amp;exceptionInfo, bool updateAliases=TRUE)</td></tr>
<tr class="separator:aeed6f486bee7176ca8a4f3af3836f3d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5cb01977ec8a3870579e803ef6e4ce04"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#a5cb01977ec8a3870579e803ef6e4ce04">_fwConfigurationDB_selectDevicesToLoad</a> (string configurationName, string hierarchyType, dyn_string &amp;deviceList, dyn_string &amp;exceptionInfo, string topNode=&quot;&quot;)</td></tr>
<tr class="separator:a5cb01977ec8a3870579e803ef6e4ce04"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a089a0150bf52ce8681cefb2ba122a878"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#a089a0150bf52ce8681cefb2ba122a878">fwConfigurationDB_saveDevicesToDBMinimal</a> (dyn_string &amp;deviceList, dyn_string &amp;exceptionInfo, bool abortWhenDeviceMissing=FALSE)</td></tr>
<tr class="separator:a089a0150bf52ce8681cefb2ba122a878"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aebe59cb1e80fcf0c4cb92d55d9dd03be"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#aebe59cb1e80fcf0c4cb92d55d9dd03be">fwConfigurationDB_resolveDevices</a> (dyn_string &amp;deviceList, dyn_string &amp;devHierarchies, dyn_string &amp;devDatapoints, dyn_string &amp;exceptionInfo, bool errorOnNotFound=TRUE, dyn_string deviceSystems=&quot;&quot;)</td></tr>
<tr class="separator:aebe59cb1e80fcf0c4cb92d55d9dd03be"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3c03ecb0dffe50d216af6742dcfd1954"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html#a3c03ecb0dffe50d216af6742dcfd1954">fwConfigurationDB_findDPsFromAliases</a> (dyn_string devices, dyn_string &amp;dp_names, dyn_string &amp;aliases, dyn_string &amp;exceptionInfo, dyn_string systems=&quot;*&quot;, bool errorOnNotFound=TRUE)</td></tr>
<tr class="separator:a3c03ecb0dffe50d216af6742dcfd1954"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This package contains hierarchy-related functions of the Configuration Database tool</p>
<p>(c) Copyright CERN, All Rights Reserved </p>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="a2160aaa26b8d3c747f689aeb4b4a4b69"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2160aaa26b8d3c747f689aeb4b4a4b69">&#9670;&nbsp;</a></span>fwConfigurationDB_getHierarchyFromPVSS()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getHierarchyFromPVSS </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>rootNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>nodeList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>system</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>includeRootNode</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the list of children items, in specified hierarchy</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rootNode</td><td>the name of the parent device (item) </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>the Framework hierarchy type: <ul>
<li>fwDevice_HARDWARE for Hardware hierarchy </li>
<li>fwDevice_LOGICAL for Logical hierarchy (other hierarchies are not supported yet). </li>
</ul>
</td></tr>
    <tr><td class="paramname">nodeList</td><td>the resulting list of child items will be stored in this variable. Note that this is "append" operation, i.e. the contents of the variable are not cleared from previous content! </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">system</td><td>(optional) the name of the system (for distributed systems); when not specified, the local system is assumed </td></tr>
    <tr><td class="paramname">includeRootNode</td><td>(optional) determined if the rootNode will be included in the list; if TRUE (default) rootNode will be included, if FALSE - it will not.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_devLists">Device lists</a> section of the Quick Start. </dd></dl>

</div>
</div>
<a id="a1ac41af87b3933fc92243bc39812110e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1ac41af87b3933fc92243bc39812110e">&#9670;&nbsp;</a></span>_fwConfigurationDB_copyDeviceListObjectEntry()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _fwConfigurationDB_copyDeviceListObjectEntry </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>srcObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>src_idx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>dstObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>dst_idx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Copies one entry (line) of device object to another device object. if dst_idx=0 this is "append" operation </p>

</div>
</div>
<a id="a4b6426bf88b2da16474a53fb3d75a2b4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4b6426bf88b2da16474a53fb3d75a2b4">&#9670;&nbsp;</a></span>fwConfigurationDB_expandToDeviceListObject()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_expandToDeviceListObject </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>deviceListObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>For devices in the deviceList, the DeviceListObject is created, filled with complete information. Note that the function works for the devices that are already in the system (i.e. the function is used when saving hierarchy to DB) </p>

</div>
</div>
<a id="ae700adb9356bc6facaa480b79905a536"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae700adb9356bc6facaa480b79905a536">&#9670;&nbsp;</a></span>_fwConfigurationDB_completeDevicesInHierarchy()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _fwConfigurationDB_completeDevicesInHierarchy </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>system</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>adds the required (parent) devices to the list, puts the hierarchy in order </p>

</div>
</div>
<a id="add0cbfb4d594b22b8d4e004fc73ec52c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#add0cbfb4d594b22b8d4e004fc73ec52c">&#9670;&nbsp;</a></span>_fwConfigurationDB_verifyDatapoints()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _fwConfigurationDB_verifyDatapoints </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>deviceListObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>missingDevicesListObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>checkDeviceLocal</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>check if datapoints exist and verify that existing ones have appropriate types and models. Find and group in the missingDevicesListObject the ones that does not exist, report (with exceptionInfo) if some of them exist with incompatible type </p>

</div>
</div>
<a id="a6f03bb62117381e4a4142b49a33f7082"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6f03bb62117381e4a4142b49a33f7082">&#9670;&nbsp;</a></span>fwConfigurationDB_getReferencesHistory()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getReferencesHistory </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>configName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>startTime</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>endTime</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>itemNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>references</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns the history of hierarchies mapping for specipied period of time, and for certain configuration.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">configName</td><td>the name of static configuration </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>type of hierarchy (eg. fwDevice_LOGICAL) </td></tr>
    <tr><td class="paramname">startTime</td><td>start of queried period of time </td></tr>
    <tr><td class="paramname">endTime</td><td>end of queried period of time. Passing 0 as a parameter means: up to now </td></tr>
    <tr><td class="paramname">itemNames</td><td>list of logical names of devices being queried </td></tr>
    <tr><td class="paramname">references</td><td>the result will be put in this variable on return; explanation of the output format below </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable</td></tr>
  </table>
  </dd>
</dl>
<p>The data returned by the function has a format of 4-column array: </p><ul>
<li>references[1] contain item names (in logical view) </li>
<li>references[2] contain corresponding dp names from hardware view </li>
<li>references[3] contain the start of validity period for this mapping </li>
<li>references[4] contain the end of validity period for this mapping</li>
</ul>
<p>The rows are sorted by logical dpname and start of validity.</p>
<p>Example: </p><table style="font-size:8;">
<tr bgcolor="yellow">
<td>references[1] </td><td>references[2] </td><td>references[3] </td><td>references[4] </td></tr>
<tr>
<td>SubSys/straw1 </td><td>dist_1:CAEN/crate01/board00/channel001 </td><td>5 Jan 2006  </td><td>6 Jan 2006 </td></tr>
<tr>
<td>SubSys/straw1 </td><td>dist_1:CAEN/crate01/board00/channel011 </td><td>6 Jan 2006  </td><td>10 Jan 2006  </td></tr>
<tr>
<td>SubSys/straw1 </td><td>dist_1:CAEN/crate01/board10/channel001 </td><td>10 Jan 2006 </td><td></td></tr>
<tr>
<td>SubSys/straw2 </td><td>dist_1:CAEN/crate01/board01/channel002 </td><td>5 Jan 2006 </td><td></td></tr>
<tr>
<td>SubSys/straw3 </td><td>dist_1:CAEN/crate01/board01/channel003 </td><td>5 Jan 2006 </td><td></td></tr>
</table>
<p>In this example, one can see that the SubSys/straw1 aparently had some problems: it was initially mapped to first channel of first board, then on 6th of January 2006, reconnected to eleventh channel of first board, then again, on 10th of January 2006 it was reconnected to first channel of tenth board, and stays as such since then. The other two straws were not touched and stay connected to channel 2 and 3 on first board... </p>

</div>
</div>
<a id="aeed6f486bee7176ca8a4f3af3836f3d9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeed6f486bee7176ca8a4f3af3836f3d9">&#9670;&nbsp;</a></span>fwConfigurationDB_updateDeviceModelsInDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_updateDeviceModelsInDB </td>
          <td>(</td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>dpList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>updateAliases</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Updates the device models in the database to the current ones</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dpList</td><td>the list of datapoint names, for which the model is to be changed. Note that if the datapoin </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard framework exception-handling variable </td></tr>
    <tr><td class="paramname">updateAliases</td><td>(optional, default TRUE), determines if the models for LOGICAL devices which correspond to the specified datapoints should also be updated.</td></tr>
  </table>
  </dd>
</dl>
<p>@NOTE: Use with care and cautiously, of what the implications could be! To be used from the dedicated device-conversion panels, such as the ones for the fwWiener component.</p>
<dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000001">Reviewed:</a></b></dt><dd>2018-06-20 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-API">API</a> <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-StandaloneTool">StandaloneTool</a> </dd></dl>

</div>
</div>
<a id="a5cb01977ec8a3870579e803ef6e4ce04"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5cb01977ec8a3870579e803ef6e4ce04">&#9670;&nbsp;</a></span>_fwConfigurationDB_selectDevicesToLoad()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int _fwConfigurationDB_selectDevicesToLoad </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>configurationName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>topNode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Selects the devices to be loaded, prepares the data in ConfDB data-exchange tables.</p>
<p>There are two ways to specify the list of devices:</p><ul>
<li>explicitly: by passing it as input in deviceList parameter</li>
<li>look-up in the DB: specify the top node, such as the system name; this mode is activated by the fact of passing empty deviceList on input (on output it will be populated with device names); the topNode parameter should be passed: if left empty, the name of the current system will be taken.</li>
</ul>
<p>Then a cross-check is done on the deviceList passed on input: if all devices indeed exist in the specified configuration, the deviceList parameter, then they are sorted alphabeticaly (so that on return the deviceList param DIFFERS than the one on input) all the preparation is done and return code of zero is returned. However, if some of devices passed in deviceList are not present in the database, they will be skipped - on return a modified deviceList parameter will have the valid one, and the return value from the function will be 1</p>
<p>Return codes less than zero signify an error - details in exceptionInfo </p>

</div>
</div>
<a id="a089a0150bf52ce8681cefb2ba122a878"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a089a0150bf52ce8681cefb2ba122a878">&#9670;&nbsp;</a></span>fwConfigurationDB_saveDevicesToDBMinimal()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwConfigurationDB_saveDevicesToDBMinimal </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>abortWhenDeviceMissing</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Stores "minimal" information about the devices to DB</p>
<p>This function stores minimal information about devices into the DB, so that recipes for these devices may also be stored.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">deviceList</td><td>- list of names of devices; may include a mixture of devices from the HARDWARE and LOGICAL hierarchies; on exit, it will contain the list of devices that were actually stored/verified, namely: the non-existing devices are removed from the list, and devices that are needed to satisfy the hierarchical constraints (parents, grandparents,...) are added to the list </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">exceptionInfo</td><td>- standard exception-handling parameter </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">abortWhenDeviceMissing</td><td>(optional, default FALSE) - if set to TRUE, the function will abort (and return an error) if some of specified devices does not exist, i.e. it will not store the good ones in the database; otherwise (the default behaviour), the missing devices will be skipped, the good ones will be stored in the database, and the return value of 1 will signify that there were missing devices.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">0</td><td>- everything OK: all devices are in DB now </td></tr>
    <tr><td class="paramname">1</td><td>- some devices in the deviceList do not exist, and were skipped; the list of them is in the exceptionInfo; apart from that, everything was OK </td></tr>
    <tr><td class="paramname">-1</td><td>- there was an error while storing the devices; details in the exceptionInfo</td></tr>
  </table>
  </dd>
</dl>
<p>How to handle the return value and the exceptionInfo, when the <code>abortWhenDeviceMissing</code> parameter is <code>FALSE</code>. This example shows how to make sure that the recipeObject can be saved to DB. The devices that exist - are saved. For all devices that are missing, we post-process the recipeObject to remove the data for non-existing devices, then save the recipeObject to DB </p><div class="fragment"><div class="line">dyn_dyn_mixed recipeObject;</div>
<div class="line"><span class="comment">// ... get the recipe into the recipeObject somehow...</span></div>
<div class="line"> </div>
<div class="line">dyn_string deviceList=recipeObject[fwConfigurationDB_RO_DP_NAME];</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> rc=<a class="code" href="fwConfigurationDB__Hierarchies_8ctl.html#a089a0150bf52ce8681cefb2ba122a878">fwConfigurationDB_saveDevicesToDBMinimal</a>(deviceList,exceptionInfo,FALSE);</div>
<div class="line"><span class="keywordflow">if</span> (rc!=0) {</div>
<div class="line">  <span class="comment">// means something happen</span></div>
<div class="line">  <span class="keywordflow">if</span> (rc==-1) {</div>
<div class="line">    fwExceptionHandling_display(exceptionInfo);</div>
<div class="line">    <span class="comment">// abort!</span></div>
<div class="line">    <span class="keywordflow">return</span> FALSE;</div>
<div class="line">  } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (rc==1) {</div>
<div class="line">    <span class="comment">// it is still OK, even though some of the devices were missing:</span></div>
<div class="line">    <span class="comment">// we choose not to display the exception, but only print a message to a log</span></div>
<div class="line">    DebugN(<span class="stringliteral">&quot;There were some missing devices - the others were saved OK&quot;</span>);</div>
<div class="line">    <span class="comment">// post-process the recipeObject, to remove the missing devices...</span></div>
<div class="line">    <span class="comment">// the good ones are returned in the (modified!) deviceList</span></div>
<div class="line">    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1;i&lt;=dynlen(recipeObject[fwConfigurationDB_RO_DP_NAME]);i++) {</div>
<div class="line">      <span class="keywordtype">string</span> dev=recipeObject[fwConfigurationDB_RO_DP_NAME][i];</div>
<div class="line">      <span class="keywordflow">if</span> (!dynContains(deviceList,dev)) {</div>
<div class="line">        <span class="comment">// remove the line from all data columns of the recipeObject</span></div>
<div class="line">        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=1;j&lt;=fwConfigurationDB_RO_MAXIDX;j++) {</div>
<div class="line">          dynRemove(recipeObject[j],i);</div>
<div class="line">         }</div>
<div class="line">         i--;<span class="comment">//reset iterator</span></div>
<div class="line">       }</div>
<div class="line"> </div>
<div class="line">     }</div>
<div class="line">  }</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="comment">// we could save the recipe into the DB now...</span></div>
<div class="line"><a class="code" href="group__RecipeFunctions.html#ga5abee14f21a2a0153cedff1192fe09c5">fwConfigurationDB_saveRecipeToDB</a>(recipeObject,<span class="stringliteral">&quot;&quot;</span>,<span class="stringliteral">&quot;MyTestRecipe&quot;</span>,exceptionInfo);</div>
<div class="line"><span class="keywordflow">if</span> (dynlen(exceptionInfo)){fwExceptionHandling_display(exceptionInfo);<span class="keywordflow">return</span>;};</div>
<div class="ttc" id="afwConfigurationDB__Hierarchies_8ctl_html_a089a0150bf52ce8681cefb2ba122a878"><div class="ttname"><a href="fwConfigurationDB__Hierarchies_8ctl.html#a089a0150bf52ce8681cefb2ba122a878">fwConfigurationDB_saveDevicesToDBMinimal</a></div><div class="ttdeci">int fwConfigurationDB_saveDevicesToDBMinimal(dyn_string &amp;deviceList, dyn_string &amp;exceptionInfo, bool abortWhenDeviceMissing=FALSE)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Hierarchies.ctl:1662</div></div>
<div class="ttc" id="agroup__RecipeFunctions_html_ga5abee14f21a2a0153cedff1192fe09c5"><div class="ttname"><a href="group__RecipeFunctions.html#ga5abee14f21a2a0153cedff1192fe09c5">fwConfigurationDB_saveRecipeToDB</a></div><div class="ttdeci">void fwConfigurationDB_saveRecipeToDB(dyn_dyn_mixed recipeObject, string hierarchyType, string recipeName, dyn_string &amp;exceptionInfo, string versionDescription=&quot;&quot;, bool autoSaveDevices=FALSE)</div><div class="ttdef"><b>Definition:</b> fwConfigurationDB_Recipes.ctl:265</div></div>
</div><!-- fragment --> 
</div>
</div>
<a id="aebe59cb1e80fcf0c4cb92d55d9dd03be"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aebe59cb1e80fcf0c4cb92d55d9dd03be">&#9670;&nbsp;</a></span>fwConfigurationDB_resolveDevices()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_resolveDevices </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>devHierarchies</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>devDatapoints</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>errorOnNotFound</em> = <code>TRUE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceSystems</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Resolves device names</p>
<p>This functions takes the list of device names - devices being in either hierarchy, and tells what are the actual hierarchy to which they belong, and what are the datapoint to which they refer</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">deviceList</td><td>list of devices to be resolved; on return contains a modified list of resolved devices (ie those that are not resolved are skipped; could be useful if errorOnNotFound is set to false, because otherwise exceptionInfo is generated and the list is not modified</td></tr>
    <tr><td class="paramname">devHierarchies</td><td>on exit will contain the name of hierarchy for all the elements of deviceList</td></tr>
    <tr><td class="paramname">devDatapoints</td><td>on return will contain the name of datapoints for all the elements of deviceList</td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable</td></tr>
    <tr><td class="paramname">errorOnNotFound</td><td>determines if an exception should be generated when a non-resolved device is encountered (default: true)</td></tr>
    <tr><td class="paramname">deviceSystems</td><td>(optional) list of systems on which devices should be resolved. by default (empty dyn_string, or a dyn_string with one element being an empty string would look up on the local system only; if set to a "*" (ie. dyn_string with 1 element being "*"), it will look up in all known systems </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a3c03ecb0dffe50d216af6742dcfd1954"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3c03ecb0dffe50d216af6742dcfd1954">&#9670;&nbsp;</a></span>fwConfigurationDB_findDPsFromAliases()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_findDPsFromAliases </td>
          <td>(</td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>devices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>dp_names</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>aliases</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>systems</em> = <code>&quot;*&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>errorOnNotFound</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Resolve aliases to datapoints</p>
<p>this function resolves a list of aliases to datapoints, allowing to choose in which systems to try to resolve the aliases, and allowing to select different methods (eg. searching on all systems at once or searching for each of the selected systems at a time) to resolve the aliases which depending on the use-case may have a significant difference in performance.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">devices</td><td>- list of names of devices; Any HARDWARE devices are ignored, only LOGICAL hierarchie devices are considered. may include a mixture of devices from the HARDWARE and LOGICAL hierarchies; </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">dp_names</td><td>- the returned list of datapoints </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">aliases</td><td>- the returned list of aliases </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">exceptionInfo</td><td>- standard exception-handling parameter </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">systems</td><td>- (optional) A list of the system where to try to resolve the aliases; <b>""</b> or an empty list can be passed to resolve only for the local system, and <b>"*"</b> for all systems (default). </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">errorOnNotFound</td><td>- (optional, default TRUE) Return an error on exceptionInfo in case it is not possible to resolve any of the devices. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="ab428a42aec45f67f0ebb3daffa4c3cde"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab428a42aec45f67f0ebb3daffa4c3cde">&#9670;&nbsp;</a></span>fwConfigurationDB_DLO_MODEL</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">fwConfigurationDB_DLO_MODEL = 5</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>{@</p>
<p>contains model name for framework devices, "DATAPOINT" if this is a non-framework data point, "SYSTEM" if this is a top-node of hierarchy </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="fwConfigurationDB__Hierarchies_8ctl.html">fwConfigurationDB_Hierarchies.ctl</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
